❓ 문제 - 백준 벽 부수고 이동하기4 16946번 - JAVA 풀이법
출처
(https://www.acmicpc.net/problem/16946)
📝 문제해결법
1. 문제
- 벽은 1, 이동할 수 있는 곳은 0인데 각 벽에 대해서 이동할 수 있다고 하면 최대 이동할 수 있는 칸의 개수를 나타내라.
2. 해결 방법
- 우선 N, M의 각 범위가 1이상 1000이하 이므로 각 벽에 대해서 이동허락했을 때 BFS를 돌리면 N^2 * M ^2로 당연히 시간 초과가 난다.
- 여기서 생각의 관점을 바꿔서 벽을 기준으로 BFS를 돌리는 것이 아닌, 이동할 수 있는 곳을 기준으로 BFS를 돌린다.
- 그 후 각 벽에 위치에서 4방향으로 0(이동할 수 있는 곳)의 최대 이동 칸을 다 더해서 출력한다.
- BFS를 돌릴 때 연결된 구간(그룹) 내에서는 최대 이동할 수 있는 칸이 같기 때문에 최대 이동칸을 더할 때 같은 그룹에 포함된 것의 중복을 제거한 상태로 더해야 한다.
- 따라서 BFS 내에서 같은 그룹처리를 표시할 수 있는 group 배열 이용하고 각 그룹에 최대 이동칸을 표시할 수 있도록 queue와 ans 2차원 배열을 이용한다.
3. 느낀점
- 구현까지 했는데 계속 시간 초과라서.. 뭐지 하면서 다른 사람 풀이 보니깐
- 출력을 할 때 다시 한번 2중 포문으로 n*m 번의 접근이 이루어지는데 이러면 시간초과가 발생한다. 그러나 벽을 기준으로 4방향의 0의 최대 이동칸수 더할 때 sb에 append해서 한번에 출력하면 시간초과가 발생하지 않는다..! 이점 주의하시오 ㅎㅎ
💻 소스코드 (JAVA)
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.LinkedList;
import java.util.Queue;
import java.util.StringTokenizer;
public class Main_16946 {
public static int n, m;
public static int[][] map;
public static int[][] cnt;
public static int[][] ans;
public static int[][] group;
public static class Node {
int x;
int y;
public Node(int x, int y){
this.x = x;
this.y = y;
}
}
public static int g_cnt;
public static int[] dx = {-1, 1, 0, 0};
public static int[] dy = {0, 0, -1, 1};
public static void main(String[] args) throws IOException {
BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
StringTokenizer st = new StringTokenizer(br.readLine(), " ");
StringBuilder sb = new StringBuilder();
n = Integer.parseInt(st.nextToken());
m = Integer.parseInt(st.nextToken());
map = new int[n][m];
ans = new int[n][m];
cnt = new int[n][m];
group = new int[n][m];
for(int i=0;i<n;i++){
char[] c = br.readLine().toCharArray();
for(int j=0;j<m;j++){
map[i][j] = c[j] - '0';
}
}
int bfs_cnt = 0;
for(int i=0;i<n;i++){
for(int j=0;j<m;j++){
if(map[i][j] == 0 && group[i][j] == 0){
g_cnt++;
bfs_cnt++;
bfs(i, j);
}
}
}
for(int i=0;i<n;i++){
for(int j=0;j<m;j++){
if(map[i][j] == 1){
boolean[] check = new boolean[g_cnt+1];
int sum = 0;
for(int d=0;d<4;d++){
int nx = i + dx[d];
int ny = j + dy[d];
if(nx < 0 || nx >= n || ny < 0 || ny >= m) continue;
if(map[nx][ny] == 0) {
int g = group[nx][ny];
if(check[g]){
continue;
} else {
sum += ans[nx][ny];
check[g] = true;
}
}
}
sb.append((sum+1)%10);
}else {
sb.append(0);
}
}
sb.append("\n");
}
System.out.println(sb.toString());
}
public static void bfs(int x, int y){
Queue<Node> q = new LinkedList<>();
Queue<Node> q2 = new LinkedList<>();
int c = 1;
q.add(new Node(x, y));
q2.add(new Node(x, y));
group[x][y] = g_cnt;
while (!q.isEmpty()){
Node node = q.poll();
for(int d=0;d<4;d++){
int nx = node.x + dx[d];
int ny = node.y + dy[d];
if(nx < 0 || nx >= n || ny < 0 || ny >= m) continue;
if(group[nx][ny] != 0) continue;
if(map[nx][ny] != 0 ) continue;
group[nx][ny] = g_cnt;
c++;
q.add(new Node(nx, ny));
q2.add(new Node(nx, ny));
}
}
while (!q2.isEmpty()){
Node node = q2.poll();
ans[node.x][node.y] = c;
}
}
}
'알고리즘 > 알고리즘문풀' 카테고리의 다른 글
BOJ - 우주신과의 교감 1774번 (JAVA) (0) | 2022.09.10 |
---|---|
BOJ - 다리 만들기 2146번 (JAVA) (0) | 2022.09.09 |
BOJ - 정육면체 9029번 (JAVA) (0) | 2022.08.28 |
BOJ - 친구 네트워크 4195번 (JAVA) (0) | 2022.08.25 |
BOJ - 소풍 2026번 (JAVA) (0) | 2022.08.23 |